package blacklinen.msf.jeasyzip;

import java.io.FileNotFoundException;

import blacklinen.msf.jeasyzip.gui.JEasyZipProgressMonitor;
import blacklinen.msf.jeasyzip.io.packer.FileZipper;

public class CompressThread extends Thread
{
    protected JEasyZipController cont;
    protected String toFile;
    protected FileZipper currentPacker;
    protected JEasyZipProgressMonitor proMon;
    
    public CompressThread(JEasyZipController cont)
    {
	this.cont = cont;
    }
    
    public void compress(String toFile)
    {
	this.toFile = toFile;
	if(this.cont.getStore().size() > 0)
	{
	    try
	    {
		this.cont.getWindow().getCompressButton().setEnabled(false);
		this.proMon = new JEasyZipProgressMonitor(this.cont.getWindow());
		this.proMon.setLocationRelativeTo(this.cont.getWindow());
		this.proMon.showDialog(JEasyZipProgressMonitor.compress);
		this.currentPacker = new FileZipper(toFile);
		this.currentPacker.compressFiles(this.cont.getStore().getFileElementArray());
		this.start();
	    } 
	    catch (FileNotFoundException e)
	    {
		e.printStackTrace();
	    }  
	}
    }
    
    public void run()
    {
	while(this.currentPacker.isAlive());
	this.proMon.dispose();
	this.cont.getWindow().getCompressButton().setEnabled(true);
    }
}
