package blacklinen.msf.jeasyzip;

import java.io.FileNotFoundException;
import java.io.IOException;

import blacklinen.msf.jeasyzip.gui.JEasyZipProgressMonitor;
import blacklinen.msf.jeasyzip.io.unzipper.ZipDecorder;

public class DecompressThread extends Thread
{
    protected JEasyZipController cont;
    protected String file;
    protected ZipDecorder currentDecorder;
    protected JEasyZipProgressMonitor proMon;
    
    public DecompressThread(JEasyZipController cont, String source) throws IOException
    {
	super();
	this.currentDecorder = new ZipDecorder(new String(source));
	this.cont = cont;
    }
    
    public void decompress(String file)
    {
	this.file = file;
	try
	{
		this.proMon = new JEasyZipProgressMonitor(this.cont.getWindow());
		this.proMon.setLocationRelativeTo(this.cont.getWindow());
		this.proMon.showDialog(JEasyZipProgressMonitor.uncompress);
		this.currentDecorder.decode(file, this.cont);
		this.start();
	} 
	catch (FileNotFoundException e)
	{
		e.printStackTrace();
	}  
    }
    
    public void run()
    {
	while(this.currentDecorder.isAlive());
	this.proMon.dispose();
	this.cont.getWindow().getCompressButton().setEnabled(true);
    }
}
