package blacklinen.msf.jeasyzip;

import java.io.File;
import java.io.IOException;

import javax.swing.JOptionPane;

import blacklinen.msf.jeasyzip.gui.JEasyZipProgressMonitor;
import blacklinen.msf.jeasyzip.gui.JEasyZipWindow;
import blacklinen.msf.jeasyzip.io.FileStore;
import blacklinen.msf.jeasyzip.io.packer.FileZipper;
import blacklinen.msf.jeasyzip.io.unzipper.OverrideHandler;

public class JEasyZipController implements OverrideHandler
{
    protected JEasyZipWindow window;
    protected FileStore store;
    protected JEasyZipProgressMonitor proMon;
    protected FileZipper currentPacker;
    
    public JEasyZipController()
    {
	this.store = new FileStore();
	this.window = new JEasyZipWindow(this);
    }

    public void compress(String toFile)
    {
	CompressThread comp = new CompressThread(this);
	comp.compress(toFile);
    }

    public void decompress(String fromFile, String toFile)
    {
	DecompressThread decomp;
	try
	{
	    decomp = new DecompressThread(this, fromFile);
	    decomp.decompress(toFile);
	} 
	catch (IOException e)
	{
	    System.out.println("Exception");
	    e.printStackTrace();
	}
    }
    
    public void addFile(File f)
    {
	this.store.addFile(f);
    }

    public JEasyZipWindow getWindow()
    {
	return this.window;
    }

    public FileStore getStore()
    {
	return this.store;
    }

    @Override
    public boolean overrideFile(File f)
    {
	int result = JOptionPane.showConfirmDialog(this.window, "The file: "+f.getPath()+" exists already.\n Should JEasyZip override it or leave it unchanged?", "File exsists already.", JOptionPane.YES_NO_OPTION);
	if(result == JOptionPane.YES_OPTION)
	    return true;
	return false;
    }
}
