package blacklinen.msf.jeasyzip.gui;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.TransferHandler;

import blacklinen.msf.jeasyzip.JEasyZipController;

@SuppressWarnings("serial")
public class FileTransfer extends TransferHandler
{
    protected JEasyZipController cont;
    
    public FileTransfer(JEasyZipController cont)
    {
	super();
	this.cont = cont;
    }
    
    public boolean canImport(TransferSupport sup)
    {
	if(sup.isDataFlavorSupported(DataFlavor.javaFileListFlavor))
	{
	    if(sup.getUserDropAction() == TransferHandler.MOVE)
		sup.setDropAction(TransferHandler.COPY);
	    return true;
	}
	return false;
    }
    
    @SuppressWarnings("unchecked")
    public boolean importData(TransferSupport sup)
    {
	JEasyZipFileList source = (JEasyZipFileList) sup.getComponent();
	if(sup.isDataFlavorSupported(DataFlavor.javaFileListFlavor))
	{
	    try
	    {
		List<File> files = (List<File>) sup.getTransferable().getTransferData(DataFlavor.javaFileListFlavor);
		for(File f : files)
		{
		    if(!f.getName().endsWith("zip"))
		    {
			source.add(f.getName());
			this.cont.addFile(f);
		    }
		    else
		    {
			int result = JOptionPane.showConfirmDialog(this.cont.getWindow(), "This an already compressed file!\nDo you wanna umcompress it, then click \"OK\".\nOr click chancel to add it to the list.", "Compressed file...", JOptionPane.OK_CANCEL_OPTION);
			if(result == JOptionPane.OK_OPTION)
			{
			    JFileChooser chooser = new JFileChooser();
			    chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			    int res = chooser.showSaveDialog(this.cont.getWindow());
			    if(res == JFileChooser.APPROVE_OPTION)
				this.cont.decompress(f.getPath(), chooser.getSelectedFile().getPath());
			}
			else if(result == JOptionPane.CANCEL_OPTION)
			{
			    source.add(f.getName());
			    this.cont.addFile(f);
			}
		    }
		}
		
	    } 
	    catch (UnsupportedFlavorException e)
	    {
		e.printStackTrace();
	    } 
	    catch (IOException e)
	    {
		e.printStackTrace();
	    } 
	}
	return false;
    }
}
