package blacklinen.msf.jeasyzip.io.packer;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import blacklinen.msf.jeasyzip.io.FileElement;

public class FileZipper extends Thread implements FilePacker
{
    public static final int buffer = 8192;
    protected ZipOutputStream str;
    protected FileElement[] files;
    
    public FileZipper(String file) throws FileNotFoundException
    {
	this.str = new ZipOutputStream(new FileOutputStream(file));
    }
    
    public void run()
    {
	try
	{
	    this.compress();
	} 
	catch (IOException e)
	{
	    e.printStackTrace();
	}
    }
    
    @Override
    public void compressFiles(FileElement[] files)
    {
	this.files = files;
	this.start();
    }
    
    public boolean compress() throws IOException
    {
	for(FileElement f: this.files)
	{
	    System.out.println("Zipping: "+f.getRealFile().getPath());
	    ZipEntry entry = new ZipEntry(f.getEntryName());
	    this.str.putNextEntry(entry);
	    this.compressFile(f.getRealFile());
	    this.str.closeEntry();
	}
	this.str.close();
	return false;
    }

    protected void compressFile(File f) throws IOException
    {
	FileInputStream in = new FileInputStream(f);
	byte[] cache = new byte[FileZipper.buffer];
	int i = 0;
	while((i = in.read(cache, 0, FileZipper.buffer)) != -1)
	{
	    this.str.write(cache, 0, i);
	}
	in.close();
    }
    
    protected String createPath(File f1, File f2)
    {
	if(f1.equals(f2))
	    return f1.getName();
	else
	{
	    System.out.println(f1.getPath()+" make relative to "+f2.getPath());
	    String str = f1.getPath();
	    str = str.substring((f2.getPath().length()-f2.getName().length()));
	    System.out.println(str.replace("\\", "/"));
	    return str.replace("\\", "/");
	}
    }

}
