package blacklinen.msf.jeasyzip.io.unzipper;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import blacklinen.msf.jeasyzip.io.packer.FileZipper;

public class ZipDecorder extends Thread
{
    public static final int buffer = 8192;
    protected String target;
    protected ZipInputStream instr;
    protected OverrideHandler handler;
    
    
    public ZipDecorder(String file) throws IOException
    {
	super();
	System.out.println(file);
	this.instr = new ZipInputStream(new FileInputStream(file));
    }
    
    public void decode(String target, OverrideHandler handler) throws FileNotFoundException
    {
	System.out.println("Unzipping to:"+target);
	this.target = new String(target);
	this.handler = handler;
	this.start();
    }
    
    public void run()
    {
	ZipEntry entry = null;
	try
	{
	    while((entry = this.instr.getNextEntry()) != null)
	    {
		System.out.print("Unzipping: "+entry.getName());
	        File f = new File(target, entry.getName());
	        System.out.println(" to: "+f.getPath());
	        System.out.println(f.exists());
	        if(f.exists())
	        {
	            if(!this.handler.overrideFile(f))
	        	break;
	        }
	        new File(f.getParent()).mkdirs();
        	f.createNewFile();
        	if(f.exists() && f.canWrite())
        	{		
        	    FileOutputStream outstr = new FileOutputStream(f);
        	    byte[] cache = new byte[ZipDecorder.buffer];
        	    int i = 0;
        	    while((i = instr.read(cache, 0, FileZipper.buffer)) != -1)
        	    {
    	    	    	outstr.write(cache, 0, i);
    	    	    }
    	    	instr.closeEntry();
        	}
	    }
	    instr.close();
	} 
	catch (IOException e)
	{
	    e.printStackTrace();
	}
    }
}
